// move all registers to jmSysObj to avoid null pointer in line 513 when 
// passing a submenu with no icon instead of a menu item with an icon

/*
 * AllPurposeMenu.java
 *
 * Created on April 8, 2002, 9:13 PM
 */

//package panelsAndTools;

import javax.swing.*;
import java.lang.*;
import java.awt.event.*;
import java.util.*;

/**
 *
 * @author  _
 * @version 
 */

public class AllPurposeMenu extends JPopupMenu 
    implements SortableDeclarationsTableModelListener, ActionListener { 
       public AllPurposeMenu( ActionListener alThisListener ) {

        super();  
        
        JMenuItem jmiMenuItem;
        ImageIcon iiThisIcon;
                
        DataObject doTemp = new DataObject();
        //if ( alThisListener == null )
        //    System.out.println( "In APM, alThisListener is NULL" );
        //else
        //    System.out.println( "In APM, alThisListener is NOT NULL" );

        alMenuListener = alThisListener;                

        //if ( alMenuListener == null )
        //    System.out.println( "In APM, alMenuListener is NULL" );
        //else
        //    System.out.println( "In APM, alMenuListener is NOT NULL" );

        bsMenuEnablingFlags = new BitSet( I_NUMBER_OF_FLAGS );

        // default...set for all
        for ( int iIndex = 0; iIndex < I_NUMBER_OF_FLAGS; iIndex++ ) {
            bsMenuEnablingFlags.set( iIndex );
        }

//        jmMain = new JMenu( ST_MENUITEM__MAIN_MENU );
        jmFile = new JMenu( ST_MENUITEM__MAIN_FILE_MENU );
        jmiFileNew = new JMenuItem( ST_MENUITEM__MAIN_FILE_NEW );
        jmiFileRename = new JMenuItem( ST_MENUITEM__MAIN_FILE_RENAME );
        jmiFileOpen = new JMenuItem( ST_MENUITEM__MAIN_FILE_OPEN );
        jmiFileSave = new JMenuItem( ST_MENUITEM__MAIN_FILE_SAVE );
        jmiFileSaveAs = new JMenuItem( ST_MENUITEM__MAIN_FILE_SAVE_AS );
        jmiFileGenerateCode = new JMenuItem( ST_MENUITEM__MAIN_FILE_GENERATE_CODE );
        jmiFileExit = new JMenuItem( ST_MENUITEM__MAIN_FILE_EXIT );    
                
        jmEdit = new JMenu( ST_MENUITEM__MAIN_EDIT_MENU );
        jmiEditCut = new JMenuItem( ST_MENUITEM__MAIN_EDIT_CUT );
        jmiEditCopy = new JMenuItem( ST_MENUITEM__MAIN_EDIT_COPY );
        jmiEditPaste = new JMenuItem( ST_MENUITEM__MAIN_EDIT_PASTE );
        jmiEditPaste.setEnabled( false );
        
        jrbmiEditCodeInsert = 
            new JRadioButtonMenuItem( ST_MENUITEM__MAIN_EDIT_CODE_INSERT );
        jrbmiEditCodeInsert.addActionListener( this );
        
        jrbmiEditCodeOverwrite = 
            new JRadioButtonMenuItem( ST_MENUITEM__MAIN_EDIT_CODE_OVERWRITE );
        jrbmiEditCodeOverwrite.addActionListener( this );

        bgCodeEditingOptions = new ButtonGroup();
        bgCodeEditingOptions.add( jrbmiEditCodeInsert );
        bgCodeEditingOptions.add( jrbmiEditCodeOverwrite );

        jmHelp = new JMenu( ST_MENUITEM__MAIN_HELP_MENU );
        jmHelpMenuUsage = new JMenu( ST_MENUITEM__MAIN_HELP_MENU_USAGE );
        jmiHelpGeneral1 = new JMenuItem( ST_MENUITEM__MAIN_HELP_GENERAL1 );
        jmiHelpGeneral2 = new JMenuItem( ST_MENUITEM__MAIN_HELP_GENERAL2 );
        jmiHelpArrays = new JMenuItem( ST_MENUITEM__MAIN_HELP_ARRAYS );
        jmiHelpLiterals = new JMenuItem( ST_MENUITEM__MAIN_HELP_LITERALS );
        jmiHelpMenuUsageFile = new JMenuItem( ST_MENUITEM__MAIN_HELP_MENU_USAGE_FILE );
        jmiHelpMenuUsageEdit = new JMenuItem( ST_MENUITEM__MAIN_HELP_MENU_USAGE_EDIT );
        jmiHelpMenuUsageView = new JMenuItem( ST_MENUITEM__MAIN_HELP_MENU_USAGE_VIEW );
        jmiHelpMenuUsageObjects = new JMenuItem( ST_MENUITEM__MAIN_HELP_MENU_USAGE_OBJECTS );
        jmiHelpMenuUsageHelp = new JMenuItem( ST_MENUITEM__MAIN_HELP_MENU_USAGE_HELP );
        jmiHelpAbout = new JMenuItem( ST_MENUITEM__MAIN_HELP_ABOUT );
        
        jmViewPanel = new JMenu( ST_MENUITEM__PANEL_MENU );
        jmiViewPanelBranchAndCompare = new JMenuItem( ST_MENUITEM__PANEL_BRANCH_COMPARE );
        jmiViewPanelMath = new JMenuItem( ST_MENUITEM__PANEL_MATH );
        jmiViewPanelMoveAll = new JMenuItem( ST_MENUITEM__PANEL_MOVE );
        jmiViewPanelMoveParts = new JMenuItem( ST_MENUITEM__PANEL_MOVE_PARTS );
        jmiViewPanelObjectEditor = new JMenuItem( ST_MENUITEM__PANEL_OBJECT_EDITOR );
        jmiViewPanelSectionComments = new JMenuItem( ST_MENUITEM__PANEL_COMMENTS );
        jmiViewPanelForInstruction = new JMenuItem( ST_MENUITEM__PANEL_FOR_INSTRUCTION );

        jmUserObjects = new JMenu( ST_MENUITEM__USEROBJ_MENU );
        jmUserObjectConstant = new JMenu( ST_MENUITEM__USEROBJ_CONSTANT );
        jmUserObjectVariable = new JMenu( ST_MENUITEM__USEROBJ_VARIABLE );
        jmUserLabelObjects = new JMenu( ST_MENUITEM__USEROBJ_LABEL );        
        

        jmSystemObjects = new JMenu( ST_MENUITEM__SYSOBJ_MENU );

        doTemp.setType( DataObject.I_SYSTEM_TYPE_KEYBOARD );
        jmiSystemObjectKeyboard = new JMenuItem( ST_MENUITEM__SYSOBJ_KEYBOARD,
            doTemp.getMenuIcon() );
        doTemp.setType( DataObject.I_SYSTEM_TYPE_DISPLAY );
        jmiSystemObjectDisplay = new JMenuItem( ST_MENUITEM__SYSOBJ_DISPLAY,
            doTemp.getMenuIcon() );

        jmSystemObjectsSingleRegister = new JMenu( ST_MENUITEM__SYSOBJ_SINGREG );
        jmSystemObjectsDoubleRegister = new JMenu( ST_MENUITEM__SYSOBJ_DOUBREG );

        addMenuItem( jmFile, jmiFileNew, B_NO_SEPARATOR );
        //System.out.println( "OK-1" );
        addMenuItem( jmFile, jmiFileRename, B_USE_SEPARATOR );
        //System.out.println( "OK-2" );
        addMenuItem( jmFile, jmiFileOpen, B_NO_SEPARATOR );
        //System.out.println( "OK-3" );
        addMenuItem( jmFile, jmiFileSave, B_NO_SEPARATOR );        
        //System.out.println( "OK-4" );
        addMenuItem( jmFile, jmiFileSaveAs, B_USE_SEPARATOR );
        //System.out.println( "OK-5" );
        addMenuItem( jmFile, jmiFileGenerateCode, B_USE_SEPARATOR );
        addMenuItem( jmFile, jmiFileExit, B_NO_SEPARATOR );
        //System.out.println( "OK-6" );
        //jmMain.add( jmFile );
        //System.out.println( "OK-7" );

        addMenuItem( jmEdit, jmiEditCut, B_NO_SEPARATOR );
        //System.out.println( "OK-8" );
        addMenuItem( jmEdit, jmiEditCopy, B_NO_SEPARATOR );        
        //System.out.println( "OK-9" );
        addMenuItem( jmEdit, jmiEditPaste, B_USE_SEPARATOR );
        //System.out.println( "OK-10" );
        addMenuItem( jmEdit, jrbmiEditCodeInsert, B_NO_SEPARATOR );
        //System.out.println( "OK-11" );
        addMenuItem( jmEdit, jrbmiEditCodeOverwrite, B_NO_SEPARATOR );
        //System.out.println( "OK-12" );
        //jmMain.add( jmEdit );
        //System.out.println( "OK-13" );

        addMenuItem( jmHelp, jmiHelpGeneral1, B_NO_SEPARATOR );
        addMenuItem( jmHelp, jmiHelpGeneral2, B_NO_SEPARATOR );
        addMenuItem( jmHelp, jmiHelpArrays, B_NO_SEPARATOR );
        addMenuItem( jmHelp, jmiHelpLiterals, B_NO_SEPARATOR );
        addMenuItem( jmHelp, jmHelpMenuUsage, B_USE_SEPARATOR );
        addMenuItem( jmHelp, jmiHelpAbout, B_NO_SEPARATOR );
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageFile, B_NO_SEPARATOR );
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageEdit, B_NO_SEPARATOR );
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageView, B_NO_SEPARATOR );        
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageObjects, B_NO_SEPARATOR );
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageHelp, B_NO_SEPARATOR );        

        addMenuItem( jmViewPanel, jmiViewPanelBranchAndCompare, B_NO_SEPARATOR );
        //System.out.println( "OK-17" );
        //addMenuItem( jmViewPanel, jmiViewPanelCompare, B_NO_SEPARATOR );
        //System.out.println( "ignored...OK-18" );
        addMenuItem( jmViewPanel, jmiViewPanelMath, B_NO_SEPARATOR );
        //System.out.println( "OK-19" );
        addMenuItem( jmViewPanel, jmiViewPanelMoveAll, B_NO_SEPARATOR );
        //System.out.println( "OK-20" );
        addMenuItem( jmViewPanel, jmiViewPanelMoveParts, B_NO_SEPARATOR );
        //System.out.println( "OK-21" );
        addMenuItem( jmViewPanel, jmiViewPanelObjectEditor, B_NO_SEPARATOR );
        //System.out.println( "OK-22" );
        addMenuItem( jmViewPanel, jmiViewPanelSectionComments, B_USE_SEPARATOR );
        //System.out.println( "OK-23" );
        addMenuItem( jmViewPanel, jmiViewPanelForInstruction, B_NO_SEPARATOR );

        // add REGISTER objects
        doTemp.setType( DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER );
        iiThisIcon = doTemp.getMenuIcon();

        for ( int iIndex = SystemDeclarations.I_SINGLE_REGISTER_START; 
              iIndex <= SystemDeclarations.I_SINGLE_REGISTER_END; iIndex++ ) {
            jmiMenuItem = new JMenuItem( SystemDeclarations.st1dDataObjectNames[ iIndex ],
                iiThisIcon );
            addMenuItem( jmSystemObjects, jmiMenuItem, B_NO_SEPARATOR );
        }                
        addMenuItem( jmSystemObjects, jmiSystemObjectDisplay, B_NO_SEPARATOR );
        addMenuItem( jmSystemObjects, jmiSystemObjectKeyboard, B_NO_SEPARATOR );
        //addMenuItem( jmSystemObjects, jmSystemObjectsSingleRegister, B_NO_SEPARATOR );

        jmUserObjects.add( jmUserObjectConstant );
        jmUserObjects.add( jmUserLabelObjects );
        jmUserObjects.add( jmUserObjectVariable );
        jmiUserLiteral = new JMenuItem( ST_MENUITEM__USEROBJ_LITERAL );
        addMenuItem( jmUserObjects, jmiUserLiteral, B_NO_SEPARATOR );

        // act on these menu items locally...
        addMenuItem( jmHelp, jmiHelpGeneral1, B_NO_SEPARATOR );
        addMenuItem( jmHelp, jmiHelpGeneral2, B_NO_SEPARATOR );
        addMenuItem( jmHelp, jmiHelpArrays, B_NO_SEPARATOR );
        addMenuItem( jmHelp, jmiHelpLiterals, B_NO_SEPARATOR );
        addMenuItem( jmHelp, jmHelpMenuUsage, B_USE_SEPARATOR );
        addMenuItem( jmHelp, jmiHelpAbout, B_NO_SEPARATOR );
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageFile, B_NO_SEPARATOR );
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageEdit, B_NO_SEPARATOR );
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageView, B_NO_SEPARATOR );        
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageObjects, B_NO_SEPARATOR );
        addMenuItem( jmHelpMenuUsage, jmiHelpMenuUsageHelp, B_NO_SEPARATOR );        

        jmiHelpGeneral1.addActionListener( this );
        jmiHelpGeneral2.addActionListener( this );        
        jmiHelpArrays.addActionListener( this );
        jmiHelpLiterals.addActionListener( this );        
        jmHelpMenuUsage.addActionListener( this );
        jmiHelpAbout.addActionListener( this );        
        jmiHelpMenuUsageFile.addActionListener( this );
        jmiHelpMenuUsageEdit.addActionListener( this );        
        jmiHelpMenuUsageView.addActionListener( this );
        jmiHelpMenuUsageObjects.addActionListener( this );        
        jmiHelpMenuUsageHelp.addActionListener( this );

        this.add( jmFile );
        this.add( jmEdit );
        this.add( jmViewPanel );
        this.addSeparator();
        this.add( jmUserObjects );
        this.add( jmSystemObjects );
        this.addSeparator();
        this.add( jmHelp );
        
        //System.out.println( "FILE MENU COUNT = " + jmFile.getComponentCount() );
        //System.out.println( "FILE MENU COUNT = " + jmEdit.getComponentCount() );
        setMenuForEmptyArea();
        iLastMenuSelection = I_MENU_TYPE__INITIAL_STARTUP;
    }
    
    public static void clearData() {
        operClipboardOperand = new Operand();
        codeClipboardCode = new Code();
        bDataObjectInClipboard = false;
        bCodeInClipboard = false;
    }
   
    public void setSortableDeclarationsModel( SortableDeclarationsTableModel sdtm ) {
        //System.out.println( "APM Receiving listeners..." );
        //System.out.println( "User = " + sdtm );
        //System.out.println( "System = " + sdtm );
        
        sdtmDeclarations = sdtm;
        sdtmDeclarations.setListener( this );
    }
    
    public void setCodeObject( Code codeThisCode ) {
        codeCodeObject = codeThisCode;
    }
    
    public boolean isLabelUsed( String stLabelName ) {
        return codeCodeObject.isLabelUsed( stLabelName );
    }
        
    /////////////////////// MENU MAINTENANCE METHOD \\\\\\\\\\\\\\\\\\\\
    public void addMenuItem( JMenu jmThisMenu, JMenuItem jmiThisMenuItem,
        boolean bUseSeparator ) {

        //if ( alMenuListener == null ) 
        //    System.out.println( "In addMenuItem: alMenuListener is NULL." );
        //else 
        //    System.out.println( "In addMenuItem: alMenuListener is NOT NULL." );
        
        jmiThisMenuItem.addActionListener( alMenuListener );
        jmThisMenu.add( jmiThisMenuItem );
        //System.out.println( "Added menu item " + jmiThisMenuItem.getText() +
        //    "   to menu " + jmThisMenu.getText() );

        if ( bUseSeparator == true ) {
            jmThisMenu.addSeparator();
        }
    }
    
    //----------------- Menu Configuration Methods -------------\\
    public void setMenuForInitalStartup() {
        clearMenuSettings();
        jmiFileRename.setEnabled( false );
        jmiFileSave.setEnabled( false );
        jmiFileSaveAs.setEnabled( false );

        jmEdit.setEnabled( false );
        jmViewPanel.setEnabled( false );
        jmUserObjects.setEnabled( false );
        jmSystemObjects.setEnabled( false );
        iLastMenuSelection = I_MENU_TYPE__INITIAL_STARTUP;
    }
    
    private void unsetMenuForInitialStartup() {
        jmiFileRename.setEnabled( true );
        jmiFileSave.setEnabled( true );
        jmiFileSaveAs.setEnabled( true );

        jmFile.setEnabled( true );
        jmEdit.setEnabled( true );
        jmViewPanel.setEnabled( true );
        jmiViewPanelForInstruction.setEnabled( false );
        jmUserObjects.setEnabled( true );
        jmSystemObjects.setEnabled( true );    
    }        
        
    public void setMenuForVisualCodeTable( int iPanelType ) {
        clearMenuSettings();
        setEditPasteMenuItem( iPanelType );
        
        jmViewPanel.setEnabled( true );
        jmiViewPanelBranchAndCompare.setEnabled( false );
        jmiViewPanelMath.setEnabled( false );
        jmiViewPanelMoveAll.setEnabled( false );
        jmiViewPanelMoveParts.setEnabled( false );
        jmiViewPanelObjectEditor.setEnabled( false );
        jmiViewPanelSectionComments.setEnabled( false );
        jmiViewPanelForInstruction.setEnabled( true );

        jmFile.setEnabled( false );
        jmUserObjects.setEnabled( false );
        jmSystemObjects.setEnabled( false );
        iLastMenuSelection = I_MENU_TYPE__VISUAL_CODE_TABLE;
    }
    
    private void unsetMenuForVisualCodeTable() {
        jmiEditPaste.setEnabled( true );

        jmViewPanel.setEnabled( true );
        jmiViewPanelBranchAndCompare.setEnabled( true );
        jmiViewPanelMath.setEnabled( true );
        jmiViewPanelMoveAll.setEnabled( true );
        jmiViewPanelMoveParts.setEnabled( true );
        jmiViewPanelObjectEditor.setEnabled( true );
        jmiViewPanelSectionComments.setEnabled( true );
        jmiViewPanelForInstruction.setEnabled( false );        
        
        jmFile.setEnabled( true );
        jmUserObjects.setEnabled( true );
        jmSystemObjects.setEnabled( true );
    }    
    
    public void setMenuForDataObjectArea( int iPanelType ) {
        clearMenuSettings();
        setEditPasteMenuItem( iPanelType );
        
        jmFile.setEnabled( false );
        jmViewPanel.setEnabled( false );
        iLastMenuSelection = I_MENU_TYPE__DATA_OBJECT_AREA;
    }
    
    private void unsetMenuForDataObjectArea() {
        jmiEditPaste.setEnabled( true );
        
        jmFile.setEnabled( true );
        jmViewPanel.setEnabled( true ); 
        jmiViewPanelForInstruction.setEnabled( false );
    }
    
    public void setMenuForEmptyArea() {
        clearMenuSettings();
        jmiEditCut.setEnabled( false );
        jmiEditCopy.setEnabled( false );
        jmiEditPaste.setEnabled( false );
        
        jmiViewPanelForInstruction.setEnabled( false );
        
        jmUserObjects.setEnabled( false );
        jmSystemObjects.setEnabled( false );
        iLastMenuSelection = I_MENU_TYPE__EMPTY_AREA;
    }

    private void unsetMenuForEmptyArea() {
        jmiEditCut.setEnabled( true );
        jmiEditCopy.setEnabled( true );
        jmiEditPaste.setEnabled( true );

        jmUserObjects.setEnabled( true );
        jmSystemObjects.setEnabled( true );            
    }

    public void setMenuForEmptyPanelArea() {
        clearMenuSettings();
        jmiEditCut.setEnabled( false );
        jmiEditCopy.setEnabled( false );
        jmiEditPaste.setEnabled( false );
        
        jmFile.setEnabled( false );
        jmViewPanel.setEnabled( false );
        jmUserObjects.setEnabled( false );
        jmSystemObjects.setEnabled( false );
        iLastMenuSelection = I_MENU_TYPE__EMPTY_PANEL_AREA;
    }

    private void unsetMenuForEmptyPanelArea() {
        jmiEditCut.setEnabled( true );
        jmiEditCopy.setEnabled( true );
        jmiEditPaste.setEnabled( true );

        jmFile.setEnabled( true );
        jmViewPanel.setEnabled( true );
        jmiViewPanelForInstruction.setEnabled( false );
        jmUserObjects.setEnabled( true );
        jmSystemObjects.setEnabled( true );            
    }
        
    public void setMenuForLabelArea() {
        clearMenuSettings();
        jmiEditCut.setEnabled( true );
        jmiEditCopy.setEnabled( false );
        jmiEditPaste.setEnabled( false );
        
        jmUserLabelObjects.setEnabled( true );
        jmFile.setEnabled( false );
        jmViewPanel.setEnabled( false );
        jmSystemObjects.setEnabled( false );
        jmUserObjectConstant.setEnabled( false );
        jmUserObjectVariable.setEnabled( false );
        jmiUserLiteral.setEnabled( false );
        iLastMenuSelection = I_MENU_TYPE__LABEL_AREA;
    }

    private void unsetMenuForLabelArea() {
        jmiEditCopy.setEnabled( true );
        jmiEditPaste.setEnabled( true );
        
        jmFile.setEnabled( true );
        jmViewPanel.setEnabled( true );
        jmiViewPanelForInstruction.setEnabled( false );
        jmSystemObjects.setEnabled( true );
        jmUserObjectConstant.setEnabled( true );
        jmUserObjectVariable.setEnabled( true );
        jmiUserLiteral.setEnabled( true );
    }
    
    private void clearMenuSettings() {
        switch ( iLastMenuSelection ) {
            case I_MENU_TYPE__INITIAL_STARTUP:
                unsetMenuForInitialStartup();
                break;
                
            case I_MENU_TYPE__VISUAL_CODE_TABLE:
                unsetMenuForVisualCodeTable();
                break;
                
            case I_MENU_TYPE__DATA_OBJECT_AREA:
                unsetMenuForDataObjectArea();
                break;
                
            case I_MENU_TYPE__EMPTY_AREA:
                unsetMenuForEmptyArea();
                break;
                
            case I_MENU_TYPE__EMPTY_PANEL_AREA:
                unsetMenuForEmptyPanelArea();
                break;
                
            case I_MENU_TYPE__LABEL_AREA:
                unsetMenuForLabelArea();
                break;
        }
    }
    
    public void setDataObjectMenuRestricitions( BitSet bsNewRestrictionFlags ) {
        bsMenuEnablingFlags = bsNewRestrictionFlags;
        
        if ( bsMenuEnablingFlags.get( I_FLAG_CONSTANT ) == true ) {
            jmUserObjectConstant.setEnabled( true );            
            updateMenuItemEnabling( jmUserObjectConstant );
        }
        else {
            jmUserObjectConstant.setEnabled( false );
        }

        if ( bsMenuEnablingFlags.get( I_FLAG_LITERAL ) == true ) {
            jmiUserLiteral.setEnabled( true );
            updateMenuItemEnabling( jmUserObjectVariable );
        }
        else {
            jmiUserLiteral.setEnabled( false );
        }
        
        if ( bsMenuEnablingFlags.get( I_FLAG_VARIABLE ) == true ) {
            jmUserObjectVariable.setEnabled( true );
            updateMenuItemEnabling( jmUserObjectVariable );
        }
        else {
            jmUserObjectVariable.setEnabled( false );
        }

        if ( bsMenuEnablingFlags.get( I_FLAG_KEYBOARD_INPUT ) == true ) {
            jmiSystemObjectKeyboard.setEnabled( true );
//            System.out.println( "Keyboard *** ENABLED ***" );
        }
        else {
            jmiSystemObjectKeyboard.setEnabled( false );
//            System.out.println( "Keyboard DISABLED" );
        }

        if ( bsMenuEnablingFlags.get( I_FLAG_DISPLAY_OUTPUT ) == true ) {
            jmiSystemObjectDisplay.setEnabled( true );
//            System.out.println( "Display *** ENABLED ***" );
        }        
        else {
            jmiSystemObjectDisplay.setEnabled( false );
//            System.out.println( "Display DISABLED" );
        }
        
        if ( bsMenuEnablingFlags.get( I_FLAG_LABEL ) == true ) {
            jmUserLabelObjects.setEnabled( true );
        }
        else {
            jmUserLabelObjects.setEnabled( false );
        }
        
        if ( bsMenuEnablingFlags.get( I_FLAG_OBJECT ) == true ) {
            jmiEditCut.setEnabled( true );
            jmiEditCopy.setEnabled( true );
        }
        else {
            jmiEditCut.setEnabled( false );
            jmiEditCopy.setEnabled( false );            
        }
        
    }
    
    public void updateCodeEditingMode() {
        boolean bEditingMode;
        
        bEditingMode = codeCodeObject.getEditingMode();
        
        if ( bEditingMode == Code.B_MODE_OVERWRITE ) {
            jrbmiEditCodeOverwrite.setSelected( true );
        }
        else if ( bEditingMode == Code.B_MODE_INSERT ) {
            jrbmiEditCodeInsert.setSelected( true );
        }        
    }
    
    //---------------- ActionListener Implementation --------------\\
    public void actionPerformed( ActionEvent aeEvent ) {
        Object objEventSource;
        
        objEventSource = aeEvent.getSource();
        
        if ( objEventSource == jmiHelpGeneral1 ) {
            ptvhdAnyHelp.setTitle( "Help >> General >> Introduction (Part 1)" );
            ptvhdAnyHelp.setHelpFile( "help_general_intro1.html" );
            ptvhdAnyHelp.show();
        }
        else if ( objEventSource == jmiHelpGeneral2 ) {
            ptvhdAnyHelp.setTitle( "Help >> General >> Introduction (Part 2)" );
            ptvhdAnyHelp.setHelpFile( "help_general_intro2.html" );
            ptvhdAnyHelp.show();
        }
        else if ( objEventSource == jmiHelpArrays ) {
            ptvhdAnyHelp.setTitle( "Help >> General >> Usage of Arrays" );
            ptvhdAnyHelp.setHelpFile( "help_general_array.html" );
            ptvhdAnyHelp.show();
        }
        else if ( objEventSource == jmiHelpLiterals ) {
            ptvhdAnyHelp.setTitle( "Help >> General >> Usage of Literals" );
            ptvhdAnyHelp.setHelpFile( "help_general_literal.html" );
            ptvhdAnyHelp.show();
        }
        else if ( objEventSource == jmiHelpMenuUsageFile ) {
            ptvhdAnyHelp.setTitle( "Help >> Usage of Menus >> File" );
            ptvhdAnyHelp.setHelpFile( "help_menu_file.html" );
            ptvhdAnyHelp.show();
        }
        else if ( objEventSource == jmiHelpMenuUsageEdit ) {
            ptvhdAnyHelp.setTitle( "Help >> Usage of Menus >> Edit" );
            ptvhdAnyHelp.setHelpFile( "help_menu_edit.html" );
            ptvhdAnyHelp.show();
        }
        else if ( objEventSource == jmiHelpMenuUsageView ) {
            ptvhdAnyHelp.setTitle( "Help >> Usage of Menus >> View Panel" );
            ptvhdAnyHelp.setHelpFile( "help_menu_view.html" );
            ptvhdAnyHelp.show();
        }
        else if ( objEventSource == jmiHelpMenuUsageObjects ) {
            ptvhdAnyHelp.setTitle( "Help >> Usage of Menus >> User Objects, System Objects" );
            ptvhdAnyHelp.setHelpFile( "help_menu_objects.html" );
            ptvhdAnyHelp.show();
        }        
        else if ( objEventSource == jmiHelpMenuUsageHelp ) {
            ptvhdAnyHelp.setTitle( "Help >> Usage of Menus >> Help" );
            ptvhdAnyHelp.setHelpFile( "help_menu_help.html" );
            ptvhdAnyHelp.show();
        }
        else if ( objEventSource == jmiHelpAbout ) {
            ssAbout.show();
        }
        else if ( objEventSource == jrbmiEditCodeOverwrite ) {
            codeCodeObject.setEditingMode( Code.B_MODE_OVERWRITE );
        }
        else if ( objEventSource == jrbmiEditCodeInsert ) {
            codeCodeObject.setEditingMode( Code.B_MODE_INSERT );
        }        
    }
     
    ////////////////// CLASS METHODS  \\\\\\\\\\\\\\\\\\\\\    
    //------------------- Clipboard ------------------------\\
    public static void setOperandIntoClipboard( Operand operThisOperand ) {
        operClipboardOperand = (Operand)operThisOperand.clone();
        bDataObjectInClipboard = true;
    }
    
    // do not clone...want original reference
    public static Operand getOperandFromClipboard() {
        return operClipboardOperand;
    }
    
    public static void setCodeIntoClipboard( Code codeThisCode ) {
        codeClipboardCode = codeThisCode;
        bCodeInClipboard = true;
    }
    
    // do not clone...want original reference
    public static Code getCodeFromClipboard() {
        return codeClipboardCode;
    }
        
    //------------ Program ActionEvent Delegation ----------\\
    public void setMenuEventsForProgramActions( ActionListener alProgramListener ) {
        jmiFileNew.addActionListener( alProgramListener );
        jmiFileRename.addActionListener( alProgramListener );
        jmiFileOpen.addActionListener( alProgramListener );
        jmiFileSave.addActionListener( alProgramListener );
        jmiFileSaveAs.addActionListener( alProgramListener );
        jmiFileExit.addActionListener( alProgramListener );
    }
      
    ///////////////////// PRIVATE METHOD \\\\\\\\\\\\\\\\\\\\\\
    private void updateMenuItemEnabling( JMenu jmThisMenu ) {
        int iNumberOfMenuItems, iMenuIndex;
        String stObjectDescription;
        ImageIcon iiObjectIcon;
        JMenuItem jmiThisMenuItem;
        boolean bMenuItemSetting;

        iNumberOfMenuItems = -999;
        jmiThisMenuItem = new JMenuItem( "~~~~~" );
        stObjectDescription = "~~";
        
//      System.out.println( "APM Updating menu..." );
      //System.out.println( "Received menu = " + jmThisMenu.getText() );
      //System.out.println( "Menu enabling is " + jmThisMenu.isEnabled() );
    
        if ( jmThisMenu.isEnabled() == true ) {
            //System.out.println( "1" );
            iNumberOfMenuItems = jmThisMenu.getItemCount();
            //System.out.println( "iNumberOfMenuItems = " + iNumberOfMenuItems );
            //System.out.println( "2" );
            for ( iMenuIndex = 0; iMenuIndex < iNumberOfMenuItems; iMenuIndex++ ) {
                //System.out.println( "3" );
                jmiThisMenuItem = jmThisMenu.getItem( iMenuIndex );
                //System.out.println( "jmiThisMenuItem = " + jmiThisMenuItem.getText() );
                //System.out.println( "4" );
                iiObjectIcon = (ImageIcon)jmiThisMenuItem.getIcon();
                //System.out.println( "iiObjectIcon = " + iiObjectIcon );
                //System.out.println( "5" );
                stObjectDescription = iiObjectIcon.getDescription();
                //System.out.println( "6" );
                //              System.out.println( "jmiThisMenuItem = " + jmiThisMenuItem );
                //System.out.println( "stObjectDescription = " + stObjectDescription );

                if ( stObjectDescription.endsWith( "Character" ) ) {
                    bMenuItemSetting = false;
                    
                    if ( stObjectDescription.startsWith( "1-D" ) ) {
                        bMenuItemSetting |= 
                            bsMenuEnablingFlags.get( I_FLAG_CHARACTER_ARRAY );
                    }
                    else if ( stObjectDescription.startsWith( "Single" ) ) {
                        bMenuItemSetting |= 
                            bsMenuEnablingFlags.get( I_FLAG_CHARACTER_SINGLE );
                    }
                    bMenuItemSetting |= 
                        bsMenuEnablingFlags.get( I_FLAG_CHAR_ARRAY_ELEMENT );
                }
                else if ( ( ( stObjectDescription.startsWith( "1-D" ) )  ||
                          ( stObjectDescription.startsWith( "Single" ) ) )  &&
                          ( stObjectDescription.endsWith( "Integer" ) ) ) {
                     //System.out.println( "9" );
                    bMenuItemSetting = 
                        bsMenuEnablingFlags.get( I_FLAG_INT_SINGLE );
                    bMenuItemSetting |= 
                        bsMenuEnablingFlags.get( I_FLAG_INT_ARRAY_ELEMENT );
                            //System.out.println( "INT SINGLE" );
                }
/* NOT USED */  /*else if ( ( stObjectDescription.startsWith( "1-D" )  &&
                          ( stObjectDescription.endsWith( "Integer" ) ) {
                     bMenuItemSetting = 
                        bsMenuEnablingFlags.get( I_FLAG_INT_ARRAY );
                }*/
                else if ( stObjectDescription.startsWith( "Display" ) ) {
                    //System.out.println( "13" ); 
                    //bMenuItemSetting = 
                    //    bsMenuEnablingFlags.get( I_FLAG_CHARACTER_ARRAY );
                    //System.out.println( "14" ); 
                    bMenuItemSetting = 
                        bsMenuEnablingFlags.get( I_FLAG_DISPLAY_OUTPUT );
                    //System.out.println( "DISPLAY" );
                }
                else if ( stObjectDescription.startsWith( "Keyboard" ) ) {
                    //System.out.println( "16" ); 
                    //bMenuItemSetting = 
                    //    bsMenuEnablingFlags.get( I_FLAG_CHARACTER_ARRAY );
                    //System.out.println( "17" );
                     bMenuItemSetting = 
                        bsMenuEnablingFlags.get( I_FLAG_KEYBOARD_INPUT );
                    //System.out.println( "KEYBOARD" );
                }
                else if ( stObjectDescription.endsWith( "Register" ) ) {
                    //System.out.println( "19" ); 
                    bMenuItemSetting = 
                        bsMenuEnablingFlags.get( I_FLAG_INT_SINGLE );
                    //System.out.println( "REGISTER" );
                }
                else if ( stObjectDescription.equals( "Label" ) ) {
                    //System.out.println( "21" ); 
                    bMenuItemSetting = 
                        bsMenuEnablingFlags.get( I_FLAG_LABEL );
                    //System.out.println( "LABEL" );
                }
                else {
                    //System.out.println( "23" );
                    bMenuItemSetting = true;
                    //System.out.println( "24" );
                }
                //System.out.println( "MENU SETTING = " + bMenuItemSetting );                
                jmiThisMenuItem.setEnabled( bMenuItemSetting );
                //System.out.println( "26" );
            }  // end of loop
        }  // check if menu is enabled, else do not bother with changing disabling items

    }

    private void setEditPasteMenuItem( int iUseType ) {
        if ( iUseType == I_CODE_PANEL ) {
            if ( bCodeInClipboard == true )
                jmiEditPaste.setEnabled( true );
            else
                jmiEditPaste.setEnabled( false );
        }
        else if ( iUseType == I_INSTRUCTION_PANEL ) {
            if ( bDataObjectInClipboard == true )
                jmiEditPaste.setEnabled( true );
            else
                jmiEditPaste.setEnabled( false );
        }
    }
                    
    //--- SortableDeclarationsTableModelListener Implementation ----\\
    public void updateDeclarationsMenus( boolean bUseAllLabels ) {
        // in this list, check the list of labels already used in 
        // order to prevent duplicate label usage 
        
        int iNumberOfDeclarations, iDeclarationIndex, iRestriction;
        JMenuItem jmiThisMenuItem;
        ImageIcon iiThisMenuIcon;
        String stObjectName;
        Object objThisObject;
        NameAndDataObjectWrapper nadowThisObject;
        DataObject doThisDataObject;
        boolean bLabelUsed;
        
        jmUserObjectConstant.removeAll();
        jmUserObjectVariable.removeAll();
        jmUserLabelObjects.removeAll();
        
/*        jmUserObjectConstant.setEnabled( true );
        jmUserObjectVariable.setEnabled( true );
        jmUserLabelObjects.setEnabled( true );
        jmiUserLiteral.setEnabled( true );*/
        
        iNumberOfDeclarations = sdtmDeclarations.getRowCount();
        
        //System.out.println( "Updating APM.  Total objects = " + iNumberOfDeclarations );
        for ( iDeclarationIndex = 0; iDeclarationIndex < iNumberOfDeclarations;
            iDeclarationIndex++ ) {
                                
            objThisObject = sdtmDeclarations.getDataFromRow( iDeclarationIndex );
            
            if ( objThisObject instanceof NameAndDataObjectWrapper ) {
                nadowThisObject = (NameAndDataObjectWrapper)objThisObject;
                doThisDataObject = nadowThisObject.getObject();
                stObjectName = nadowThisObject.getName();
                //System.out.println( "Name = " + stObjectName );
                //System.out.println( "Received DataObject = " + doThisDataObject );
                iiThisMenuIcon = doThisDataObject.getMenuIcon();
                iRestriction = doThisDataObject.getRestriction();
                jmiThisMenuItem = new JMenuItem( stObjectName, iiThisMenuIcon );
                
                if ( doThisDataObject.getType() != DataObject.I_TYPE_LABEL ) {                
                    if ( iRestriction == DataObject.I_RESTRICTION_CONSTANT ) {
                        addMenuItem( jmUserObjectConstant, jmiThisMenuItem, B_NO_SEPARATOR );
                    }
                    else {
                        addMenuItem( jmUserObjectVariable, jmiThisMenuItem, B_NO_SEPARATOR );                    
                    }                
                }
                else {  // deal with label "objects"
                    bLabelUsed = codeCodeObject.isLabelUsed( stObjectName );
                
                    if ( ( bLabelUsed == false )  || 
                         ( bUseAllLabels == true ) ) {
                        addMenuItem( jmUserLabelObjects, jmiThisMenuItem, B_NO_SEPARATOR );
                    }
                    // else, do not include label in menu                    
                }
            }  // else skip if not a DataObject
        }  // end loop
        
        //System.out.println( "APM.updateDeclarationsMenus" );
        //System.out.println( "---------------------------" );
        //System.out.println( "jmUserObjectConstant = " + jmUserObjectConstant );
        //System.out.println( "jmUserObjectVariable = " + jmUserObjectVariable );
        //System.out.println( "jmSystemObjectsSingleRegister = " + jmSystemObjectsSingleRegister );
        //System.out.println( "jmSystemObjects = " + jmSystemObjects );
        System.out.println( "UPDATING ALL MENUS..." );
        updateMenuItemEnabling( jmUserObjectConstant );
        updateMenuItemEnabling( jmUserObjectVariable );
        //updateMenuItemEnabling( jmSystemObjectsSingleRegister );
        updateMenuItemEnabling( jmSystemObjects );
    }    


    // instance variables    
    private JMenu jmMain, jmFile, jmEdit, jmViewPanel,
        jmHelp, jmUserObjects, jmUserObjectConstant, jmUserObjectVariable, jmSystemObjects, 
        jmUserLabelObjects, jmSystemObjectsSingleRegister, jmSystemObjectsDoubleRegister,
        jmHelpMenuUsage; 
    private JMenuItem jmiEditCut, jmiEditCopy, jmiEditPaste, jmiViewPanelBranchAndCompare,
        jmiViewPanelCompare, jmiViewPanelMath, jmiViewPanelMoveAll, 
        jmiViewPanelMoveParts, jmiViewPanelObjectEditor, jmiViewPanelSectionComments, 
        jmiSystemObjectKeyboard, jmiSystemObjectDisplay, jmiFileNew, jmiFileRename, 
        jmiFileOpen, jmiFileSave, jmiFileSaveAs, jmiFileExit, jmiUserLiteral,
        jmiFileGenerateCode, jmiViewPanelForInstruction, jmiHelpGeneral1,
        jmiHelpGeneral2, jmiHelpArrays, jmiHelpLiterals, jmiHelpMenuUsageFile,
        jmiHelpMenuUsageEdit, jmiHelpMenuUsageView, jmiHelpMenuUsageObjects,
        jmiHelpMenuUsageHelp, jmiHelpAbout;
    private JRadioButtonMenuItem  jrbmiEditCodeInsert, jrbmiEditCodeOverwrite;
    private ButtonGroup bgCodeEditingOptions;
    private SortableDeclarationsTableModel sdtmDeclarations;
    private BitSet bsMenuEnablingFlags;
    private ActionListener alMenuListener;
    private Code codeCodeObject;
    private int iLastMenuSelection;
    
    // class variables
    private static Operand operClipboardOperand;
    private static Code codeClipboardCode;
    private static boolean bDataObjectInClipboard, bCodeInClipboard;
    private static int iEditingMenuType;
    private static PTVHelpDialog ptvhdAnyHelp; 
    private static SplashScreen ssAbout;
        
        // class constants
        private static final int I_MENU_TYPE__DATA_OBJECT_AREA = 1;
        private static final int I_MENU_TYPE__EMPTY_AREA = 2;
        private static final int I_MENU_TYPE__INITIAL_STARTUP = 3;
        private static final int I_MENU_TYPE__LABEL_AREA = 4;
        private static final int I_MENU_TYPE__VISUAL_CODE_TABLE = 5;
        private static final int I_MENU_TYPE__EMPTY_PANEL_AREA = 6;
        
        public static final int I_OK = 0;
        public static final int I_INVALID_FLAG_CODE = -1;
        
        public static final int I_UNDEFINED = -99999;
        public static final int I_CODE_PANEL = 1;
        public static final int I_INSTRUCTION_PANEL = 2;

        public static final String ST_MENUITEM__MAIN_MENU = "Main Menu";
        public static final String ST_MENUITEM__MAIN_FILE_MENU = "File";
        public static final String ST_MENUITEM__MAIN_FILE_NEW = "New Program";
        public static final String ST_MENUITEM__MAIN_FILE_RENAME = "Rename Program";        
        public static final String ST_MENUITEM__MAIN_FILE_GENERATE_CODE = "Generate Code";
        public static final String ST_MENUITEM__MAIN_FILE_OPEN = "Open";
        public static final String ST_MENUITEM__MAIN_FILE_SAVE = "Save";
        public static final String ST_MENUITEM__MAIN_FILE_SAVE_AS = "Save As";
        public static final String ST_MENUITEM__MAIN_FILE_EXIT = "Exit";

        public static final String ST_MENUITEM__MAIN_EDIT_MENU = "Edit";
        public static final String ST_MENUITEM__MAIN_EDIT_CUT  = "Cut";
        public static final String ST_MENUITEM__MAIN_EDIT_COPY  = "Copy";
        public static final String ST_MENUITEM__MAIN_EDIT_PASTE  = "Paste";
        public static final String ST_MENUITEM__MAIN_EDIT_CODE_INSERT = "Code Insert Mode";
        public static final String ST_MENUITEM__MAIN_EDIT_CODE_OVERWRITE = "Code Overwrite Mode";

        public static final String ST_MENUITEM__MAIN_HELP_MENU = "Help";
        public static final String ST_MENUITEM__MAIN_HELP_GENERAL1 = 
            "General Introduction, Part 1";
        public static final String ST_MENUITEM__MAIN_HELP_GENERAL2 = 
            "General Introduction, Part 2";
        public static final String ST_MENUITEM__MAIN_HELP_ARRAYS = "Usage of Arrays";
        public static final String ST_MENUITEM__MAIN_HELP_LITERALS = "Usage of Literals";
        public static final String ST_MENUITEM__MAIN_HELP_MENU_USAGE = "Usage of Menus";
        public static final String ST_MENUITEM__MAIN_HELP_MENU_USAGE_FILE = "File Menu";
        public static final String ST_MENUITEM__MAIN_HELP_MENU_USAGE_EDIT = "Edit Menu";
        public static final String ST_MENUITEM__MAIN_HELP_MENU_USAGE_VIEW = "View Panel Menu";
        public static final String ST_MENUITEM__MAIN_HELP_MENU_USAGE_OBJECTS = 
            "Data Objects, System Objects Menus";        
        public static final String ST_MENUITEM__MAIN_HELP_MENU_USAGE_HELP = "Help Menu";
        public static final String ST_MENUITEM__MAIN_HELP_ABOUT = 
            "About Panels::Tools::Views";

        public static final String ST_MENUITEM__PANEL_MENU = "View Panel";
        public static final String ST_MENUITEM__PANEL_BRANCH_COMPARE = "Compare & Branch";
        public static final String ST_MENUITEM__PANEL_MATH = "Math";
        public static final String ST_MENUITEM__PANEL_MOVE = "Move";
        public static final String ST_MENUITEM__PANEL_MOVE_PARTS = "Move Characters";
        public static final String ST_MENUITEM__PANEL_OBJECT_EDITOR = "Object Editor";
        public static final String ST_MENUITEM__PANEL_COMMENTS = "Section Comments";
        public static final String ST_MENUITEM__PANEL_FOR_INSTRUCTION = "Panel for This Instruction";

        public static final String ST_MENUITEM__USEROBJ_MENU = "User Objects";
        public static final String ST_MENUITEM__USEROBJ_CONSTANT = "Constant";
        public static final String ST_MENUITEM__USEROBJ_VARIABLE = "Variable";
        public static final String ST_MENUITEM__USEROBJ_LABEL = "Label";
        public static final String ST_MENUITEM__USEROBJ_LITERAL = "Literal";
        
        public static final String ST_MENUITEM__SYSOBJ_MENU = "System Objects";
        public static final String ST_MENUITEM__SYSOBJ_KEYBOARD = 
            SystemDeclarations.st1dDataObjectNames[ SystemDeclarations.I_DO_NAME_KEYBOARD ];
        public static final String ST_MENUITEM__SYSOBJ_DISPLAY = 
            SystemDeclarations.st1dDataObjectNames[ SystemDeclarations.I_DO_NAME_DISPLAY ];
        public static final String ST_MENUITEM__SYSOBJ_SINGREG = "Single Register";
        public static final String ST_MENUITEM__SYSOBJ_DOUBREG = "Double Register";

        private final static int I_OPTION_YES = 0;
        private final static int I_OPTION_NO = 1;

        private static final JMenuItem JMI_NO_MENU_ITEM = null;
        
        private static final boolean B_NO_SEPARATOR = false;
        private static final boolean B_USE_SEPARATOR = true;
        
        public static final boolean B_USE_PARTIAL_LABEL_LIST = false;
        
        public static final int I_FLAG_FIRST = 0;
        public static final int I_FLAG_CONSTANT = 0;  // includes literal
        public static final int I_FLAG_VARIABLE = 1;
        public static final int I_FLAG_LITERAL = 2;
        public static final int I_FLAG_INT_SINGLE = 3;
        public static final int I_FLAG_INT_ARRAY = 4;  // DO NOT USE
        public static final int I_FLAG_CHARACTER_SINGLE = 5;
        public static final int I_FLAG_CHARACTER_ARRAY = 6;
        public static final int I_FLAG_DISPLAY_OUTPUT = 7;
        public static final int I_FLAG_KEYBOARD_INPUT = 8;
        public static final int I_FLAG_LABEL = 9;
        public static final int I_FLAG_ALL_LABELS = 10;
        public static final int I_FLAG_OBJECT = 11;
        public static final int I_FLAG_INT_ARRAY_ELEMENT = 12;
        public static final int I_FLAG_CHAR_ARRAY_ELEMENT = 13;
        public static final int I_FLAG_LAST = 13; 
        public static final int I_NUMBER_OF_FLAGS = 14;

    // class initializer
    static {
        operClipboardOperand = new Operand();
        codeClipboardCode = new Code();
        bDataObjectInClipboard = false;
        bCodeInClipboard = false;
        iEditingMenuType = I_UNDEFINED;        
        ptvhdAnyHelp = new PTVHelpDialog( new JFrame(), "Help >> General >> Introduction" );
        ssAbout = new SplashScreen();
    }
}