/*
 * PTVFileFilter.java
 *
 * Created on June 22, 2002, 5:07 PM
 */

import java.io.File;
import javax.swing.filechooser.*;

/**
 *
 * @author  _
 * @version 
 */

// based on code given in Core Java V. 1, p. 526
// and Java Tutorial "How to Use File Choosers"

public class PTVFileFilter extends FileFilter {
    public boolean accept( File f ) {
        String stFileName = f.getName().toLowerCase();                
        return ( stFileName.endsWith( ".ptv" )  ||  f.isDirectory() );
    }
    
    public String getDescription() {
        return "Panels-Tools-Views File (*.ptv)";
    }    
}