/*
 * TypeAndIconWrapper.java
 *
 * Created on January 28, 2002, 5:26 PM
 */

//package panelsAndTools;

import javax.swing.*;
import java.io.*;

/**
 *
 * @author  _
 * @version 
 */

public class TypeAndIconWrapper implements Cloneable, Serializable {
    public TypeAndIconWrapper( String stThisTypeName, ImageIcon iiThisIcon ) {
        stType = stThisTypeName;
        iiIcon = iiThisIcon;
    }
    
    public TypeAndIconWrapper() {
        stType = new String();
        iiIcon = new ImageIcon();
    }

    protected Object clone() throws CloneNotSupportedException {
        // strucutre based on Sun's online Java tutorial for
        // the Object.clone() method and pp.235-6 C of Core Java 2: ISBN 0-13-081933-6
        try {            
            TypeAndIconWrapper taiwObject = (TypeAndIconWrapper)super.clone();
            taiwObject.iiIcon = (ImageIcon)SerializedClone.cloneObject( this.iiIcon );
            taiwObject.stType = new String( this.stType );
            
            return taiwObject;
        }
        catch ( CloneNotSupportedException cnseException ) {
            System.out.println( "Clone of TypeAndIconWrapper is not supported." );
            return null;
        }
    }
                
    public String getType() {
        return new String( stType );
        
    }
    
    public ImageIcon getIcon() {
        return (ImageIcon)SerializedClone.cloneObject( this.iiIcon );
    }

    // instance variables
    private String stType;
    private ImageIcon iiIcon;
}