/*
 * ModelError.java
 *
 * Created on January 21, 2002, 11:21 AM
 */

//package panelsAndTools;
import java.io.*;


/**
 *
 * @author  _
 * @version 
 */

public class Status implements Cloneable, Serializable {
    public Status( int iID, String stMessage ) {
        iStatusCode = iID;
        stStatusMessage = stMessage;
        System.out.println( "Status: number = " + iStatusCode + "   message = " 
            + stStatusMessage );
    }
    
    public Status( int iID ) {
        iStatusCode = iID;
        stStatusMessage = "";
        //System.out.println( "Status: I_OK" );
    }
    
    public Status() {
        iStatusCode = I_UNDEFINED;
        stStatusMessage = "";
    }
    
    public Object clone() {
//        return new Status( iStatusCode, new String( stStatusMessage ) );

        // strucutre based on Sun's online Java tutorial for
        // the Object.clone() method and pp.235-6 C of Core Java 2: ISBN 0-13-081933-6

        try {
            Status statObject = (Status)super.clone();
            statObject.stStatusMessage = new String( this.stStatusMessage );

            return statObject;
        }
        catch ( CloneNotSupportedException cnseException ) {
            System.out.println( "Clone of Status is not supported." );
            return null;
        }
    }
        
    public int getStatusNumber() {
        return iStatusCode;
    }
    
    public String getStatusMessage() {
        return new String( stStatusMessage );
    }
    
    
    // instance variables
    private int iStatusCode;
    private String stStatusMessage;
    
    private static int I_UNDEFINED = -9999999;
}    