/*
 * StructureAndDimensionsWrapper.java
 *
 * Created on February 21, 2002, 8:10 PM
 */

//package panelsAndTools;

import javax.swing.ImageIcon;
import java.lang.*;

/**
 *
 * @author  _
 * @version 
 */

public class StructureAndDimensionsWrapper implements Cloneable {

    public StructureAndDimensionsWrapper( String stThisStructure,
                                          ArrayDimensions adThisArraySize ) {
        stStructureName = stThisStructure;
        adArraySize = adThisArraySize;
    }

    public StructureAndDimensionsWrapper() {
        stStructureName = DataObject.ST_UNDEFINED;
        adArraySize = new ArrayDimensions();
    }
    
    protected Object clone() {
        // strucutre based on Sun's online Java tutorial for
        // the Object.clone() method and pp.235-6 C of Core Java 2: ISBN 0-13-081933-6        
        try {
            StructureAndDimensionsWrapper sadwObject = 
                (StructureAndDimensionsWrapper)super.clone();
            sadwObject.adArraySize = (ArrayDimensions)this.adArraySize.clone();
            sadwObject.stStructureName = new String( this.stStructureName );
            
            return sadwObject;
        }
        catch ( CloneNotSupportedException cnseException ) {
            System.out.println( "Clone of StructureAndDimensionsWrapper is not supported." );
            return null;
        }
    }

    public ArrayDimensions getArraySize() {
        return (ArrayDimensions)adArraySize.clone();        
    }

    public String getStructureName() {
        return new String( stStructureName );
    }

    // class variables
    private ArrayDimensions adArraySize;
    private String stStructureName;
}
